#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <math.h>
#include <vector>

using namespace std;


#include "aeffeditor.h"



#define GUI_WINDOW_WDT		600
#define GUI_WINDOW_HGT		330

#define GUI_VIEW_WDT		(GUI_WINDOW_WDT-20)
#define GUI_VIEW_HGT		64

enum {
	IDC_BUTTON_COPY = 1000,
	IDC_BUTTON_PASTE,
	IDC_BUTTON_LERP,
	IDC_BUTTON_CLAMP
};



class GUI:public AEffEditor
{
private:

	Evalua *plug;

	char ClassName[32];

	HWND hWndForm;
	HWND hWndStaticError; 
	HWND hWndStaticHint;
	HWND hWndButtonPoly;
	HWND hWndButtonPorta;
	HWND hWndButtonGain;
	HWND hWndButtonTimeScale;
	HWND hWndButtonLerp;
	HWND hWndButtonClamp;
	HWND hWndButtonCopy;
	HWND hWndButtonPaste;
	HWND hWndEditData;
	HWND hWndButtonDMap;
	HWND hWndStaticView;

	HFONT hFontError;
	HFONT hFontData;
	HFONT hFontButton;
	HFONT hFontHint;

	ERect rect;

	HWND MouseActiveWnd;
	POINT MousePoint;
	POINT MouseOrigin;

	const char* GetClassName(void);

	static LRESULT WINAPI WndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);

	bool NeedUpdate;
	bool NeedUpdateEdit;
	bool HlCopy;
	bool HlPaste;

	HDC hViewDC;
	HBITMAP hViewBM;

public:

	GUI(AudioEffect* effect);

	~GUI();

	virtual bool open(void* ptr);

	virtual void close();

	virtual void idle();

	virtual bool getRect(ERect **ppRect);

	void SetUpdate(bool program);

	void RenderView(void);

	bool IsMouseOver(HWND hWnd);
	void CheckParamLimits(void);
};
